import json
import io
from pkg.service.ocr import OCRService
from pkg.service.formatter import FormatService


class Extraxt:
    def read(self, stream, type="pdf", fields=None, indent=4):
        if isinstance(stream, (bytes, bytearray)):
            stream = io.BytesIO(stream)

        ocr = OCRService(type=type)
        formatter = FormatService(fields=fields)

        dataframe = ocr.read(stream)
        print("DataFrame:", dataframe)  # Debug: Print the dataframe

        content = dataframe.to_dict(orient="records")[0] if not dataframe.empty else {}
        print("Content:", content)  # Debug: Print the content

        data = formatter.format(content)
        print("Formatted Data:", data)  # Debug: Print the formatted data

        output = {section.lower(): {} for section in fields.keys()}
        formatter.apply(data, output)
        print("Output Data:", output)  # Debug: Print the output data

        return json.dumps(output, indent=indent)
